from DataRetriever import DataRetriever
from datetime import datetime
import sys

def toDatetime(dateString: str):
    return datetime.strptime(dateString[:-9], '%Y-%m-%d %H:%M:%S')

def main(processInstanceId: str, date1: datetime, date2: datetime):
    metrics = ['temperature', 'systolic', 'diastolic', 'pulse', 'spo2', 'weight']

    dr = DataRetriever(metrics)
    dfs = dr.loadDataFromDB('localhost', '8086', 'admin', 'G10m1R0m3', 'giomi')

    for df in dfs:
        df['time'] = df['time'].map(toDatetime)
    

if __name__ == '__main__':
    if len(sys.argv) != 4:
        print("Usage: python3 main.py <processInstanceId> <date1> <date2>\nDates should be given in the following format: dd-mm-aaaa")
        exit()
    
    processInstanceId = sys.argv[1]
    date1 = datetime.strptime(sys.argv[2], '%d-%m-%Y')
    date2 = datetime.strptime(sys.argv[3], '%d-%m-%Y')

    main(processInstanceId, date1, date2)

    
